// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "small.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define ID_TIMER 1

// CChildView

CChildView::CChildView()
{
	a.set(1.5,0.6);
	b.set(0.5,0.2);
	c.set(0.1,0.9);
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_CLOSE()
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

/*
	CRect win;
	GetClientRect(&win);
	CString str;
	str.Format("width %d height %d", win.Width() , win.Height());
	dc.DrawText(str,win,DT_CENTER | DT_SINGLELINE | DT_VCENTER);
*/

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	// Handle isotropic mapping
	CRect win;
	GetClientRect(&win);
	dc.SetMapMode(MM_ISOTROPIC);
	dc.SetWindowExt(480,-320);
	dc.SetViewportExt(win.Width(),win.Height());
	dc.SetViewportOrg(win.Width()/2,win.Height()/2);
	// Draw a reference grid
	CPen pen (PS_SOLID,0,RGB(220,220,255));
	CPen *oldpen = (CPen *) dc.SelectObject(&pen);
	int u = 4*point2::resolution;
	for (int i=-4; i<=4; i++) {
		int v = i*point2::resolution;
		dc.MoveTo(-u,v);
		dc.LineTo(u,v);
		dc.MoveTo(v,-u);
		dc.LineTo(v,u);
	}
	dc.SelectObject(oldpen);
	int w = 5;
	dc.Ellipse(-w,-w,w,w);

	// Draw our system of three points
	a.draw(dc);
	b.draw(dc);
	c.draw(dc);

	
	// Do not call CWnd::OnPaint() for painting messages
}


void CChildView::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	a.rotate(5.0);
	Invalidate();

	CWnd::OnTimer(nIDEvent);
}

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!SetTimer(ID_TIMER,50,NULL)) {
		AfxMessageBox(_T("SetTimer Failed"),MB_OK);
		return -1;
	}

	return 0;
}

void CChildView::OnClose()
{
	// TODO: Add your message handler code here and/or call default
	KillTimer(ID_TIMER);

	CWnd::OnClose();
}
