/*\file point2.h
*/
/*!    point2 is a two dimensional point with graphics characteristics
*/

#pragma once

#include "vec2.h"


//! defines two-dimensional graphics point
class point2: public vec2 {
public:	
	point2(): vec2(0.0,0.0) { } //!< default no-argument constructor
	~point2() {} //!< destructor
	//! constructs point2 from (x,y) coordinates
	point2(double x, double y): vec2(x,y) { }
	void convert(CPoint &dst) { convert(*this,dst); }
	static void convert(vec2 &src, CPoint &dst);
	static int resolution;
	void draw(CDC &dc);
};

inline void point2::convert(vec2 &src, CPoint &dst)
{
	dst.x = (int) (src[0]*resolution);
	dst.y = (int) (src[1]*resolution);
}
